package com.plter.hxcc.app;
import cc.Application;
import com.plter.hxcc.loader.HxccLoader;
import com.plter.hxcc.display.HxccLoaderScene;
import com.plter.hxcc.display.HxccScene;
import com.plter.lib.hx.events.EventListenerList;
class HxccApplication {

    public function new(conf:HxccConfig) {

        __instance = this;

        HxccConfig.setConfig(conf);
        _config = conf;

        preloadComplete = new EventListenerList<HxccApplicationEvent->Bool>();
        preloadError = new EventListenerList<HxccApplicationEvent->Bool>();
        preloadProgress = new EventListenerList<HxccApplicationEvent->Bool>();
        creationComplete = new EventListenerList<HxccApplicationEvent->Bool>();

        HxccLoader.loadCocos2dLib(function():Void{

            preloadComplete.dispatch(new HxccApplicationEvent(HxccApplicationEvent.PRELOAD_COMPLETE));

            __cc = CC.cc();
            Cocos2dApp = Application.extend({
            config:_config,
            ctor:function () {
                untyped __js__('this._super()');

                __cc.COCOS2D_DEBUG = _config.COCOS2D_DEBUG;
                __cc.initDebugSetting();
                __cc.setup(HxccConfig.getConfig().tag);
                __cc.AppController.shareAppController().didFinishLaunchingWithOptions();
            },
            applicationDidFinishLaunching:function () {
                if(__cc.RenderDoesnotSupport()){
                    js.Lib.alert("Browser doesn't support WebGL");
                    return false;
                }
                var director:HxccDirector = HxccDirector.getInstance();
                director.setDisplayStats(_config.showFPS);
                director.setAnimationInterval(1.0 / _config.frameRate);

                _scene = new HxccScene();

                if(_config.preloadRes!=null&&_config.preloadRes.length>0){
                    var ls:HxccLoaderScene = HxccLoaderScene.preload(_config.preloadRes,checkToRunScene,this);

                    if(_config.preloaderIcon!=null){
                        ls.setIcon(_config.preloaderIcon);
                    }
                }else{
                    checkToRunScene();
                }
                return true;
            }
            });

            Type.createInstance(Cocos2dApp,[]);
        },function(p:Float):Void{
            preloadProgress.dispatch(new HxccApplicationEvent(HxccApplicationEvent.PRELOAD_COMPLETE,null,p));
        },function(u:String):Void{
            preloadError.dispatch(new HxccApplicationEvent(HxccApplicationEvent.PRELOAD_COMPLETE,u,0));
        });
    }

    private function checkToRunScene():Void{

        var d:HxccDirector = HxccDirector.getInstance();

        if(d.getRunningScene()!=null){
            d.replaceScene(getScene());
        }else{
            d.runWithScene(getScene());
        }
        creationComplete.dispatch(new HxccApplicationEvent(HxccApplicationEvent.CREATION_COMPLETE));
    }

    public function getScene():HxccScene{
        return _scene;
    }

    private var Cocos2dApp:Dynamic;
    private var __cc:Dynamic;
    private var _scene:HxccScene;
    private var _config:HxccConfig;

    private var creationComplete:EventListenerList<HxccApplicationEvent->Bool>;
    private var preloadProgress:EventListenerList<HxccApplicationEvent->Bool>;
    private var preloadComplete:EventListenerList<HxccApplicationEvent->Bool>;
    private var preloadError:EventListenerList<HxccApplicationEvent->Bool>;

    private static var __instance:HxccApplication = null;

    public static function getInstance():HxccApplication{
        return __instance;
    }
}
